/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package org.dataone.tidy.okay.metacat;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.sql.*;
import java.util.*;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.dataone.service.types.v1.ObjectFormat;
import org.dataone.service.types.v1.ObjectFormatList;

/**
 * several methods for interacting with the metacat database in postgresql.
 * 
 * @author waltz
 */
public class MetacatDAO {

    MetacatPostgresConnection metacatPostgresConnection = new MetacatPostgresConnection();
    protected static Log log = LogFactory.getLog(MetacatDAO.class);

    public Set getMetacatIdentifiersByAuthNode(String authNodeId) throws SQLException, FileNotFoundException, IOException {
        Connection connection = metacatPostgresConnection.getPostgreSQLConnection();
        HashSet<String> identifierSet = new HashSet<String>();
        String query = "select guid from systemmetadata where authoritive_member_node like '" + authNodeId + "' LIMIT 100";
        Statement stmt = connection.createStatement();
        ResultSet rs = stmt.executeQuery(query);
        while (rs.next()) {
            String guid = rs.getString("GUID");

            identifierSet.add(guid);
        }
        return identifierSet;
    }

    public Set getMetacatIdentifiers() throws SQLException, FileNotFoundException, IOException {
        Connection connection = metacatPostgresConnection.getPostgreSQLConnection();
        HashSet<String> identifierSet = new HashSet<String>();
        String query = "select guid from systemmetadata";
        Statement stmt = connection.createStatement();
        ResultSet rs = stmt.executeQuery(query);
        while (rs.next()) {
            String guid = rs.getString("GUID");

            identifierSet.add(guid);
        }
        return identifierSet;
    }
}
